Classes | Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
MWAWChart Class Referenceabstract

a class used to store a chart associated to a spreadsheet .... More...

`#include <MWAWChart.hxx>`

Inheritance diagram for MWAWChart:

## Classes
struct | Axis
| a axis in a chart More...
struct | Legend
| a legend in a chart More...
struct | Series
| a series in a chart More...
struct | TextZone
| a text zone a chart More...

## Public Member Functions
| MWAWChart (std::string const &sheetName, MWAWFontConverterPtr const &fontConverter, MWAWVec2f const &dim=MWAWVec2f())
| the constructor More...
virtual | ~MWAWChart ()
| the destructor More...
void | sendChart (MWAWSpreadsheetListenerPtr &listener, librevenge::RVNGSpreadsheetInterface *interface)
| send the chart to the listener More...
virtual void | sendContent (TextZone const &zone, MWAWListenerPtr &listener)=0
| send the zone content (called when the zone is of text type) More...
void | setDataType (Series::Type type, bool dataStacked)
| sets the chart type More...
MWAWVec2f const & | getDimension () const
| return the chart dimension More...
void | setDimension (MWAWVec2f const &dim)
| return the chart dimension More...
void | add (int coord, Axis const &axis)
| adds an axis (corresponding to a coord) More...
Axis const & | getAxis (int coord) const
| return an axis (corresponding to a coord) More...
void | set (Legend const &legend)
| set the legend More...
Legend const & | getLegend () const
| return the legend More...
void | add (Series const &series)
| adds a series More...
std::vector< Series > const & | getSeries () const
| return the list of series More...
void | add (TextZone const &textZone)
| adds a textzone More...
bool | getTextZone (TextZone::Type type, TextZone &textZone)
| returns a textzone content(if set) More...

## Protected Member Functions
void | sendTextZoneContent (TextZone::Type type, MWAWListenerPtr &listener)
| sends a textzone content More...

## Protected Attributes
std::string | m_sheetName
| the sheet name More...
MWAWVec2f | m_dim
| the chart dimension in point More...
Series::Type | m_type
| the chart type (if no series) More...
bool | m_dataStacked
| a flag to know if the data are stacked or not More...
Axis | m_axis [4]
| the x,y,z and a bad axis More...
Legend | m_legend
| the legend More...
std::vector< Series > | m_seriesList
| the list of series More...
std::map< TextZone::Type, TextZone > | m_textZoneMap
| a map text zone type to text zone More...
MWAWFontConverterPtr | m_fontConverter
| the font converter More...

## Private Member Functions
| MWAWChart (MWAWChart const &orig)=delete
MWAWChart & | operator= (MWAWChart const &orig)=delete

## Friends
class | MWAWChartInternal::SubDocument

## Detailed Description

a class used to store a chart associated to a spreadsheet ....

## Constructor & Destructor Documentation

## ◆ MWAWChart() [1/2]

MWAWChart::MWAWChart | ( | std::string const & | sheetName,
|  | MWAWFontConverterPtr const & | fontConverter,
|  | MWAWVec2f const & | dim = `MWAWVec2f()`
| ) |  |

the constructor

## ◆ ~MWAWChart()

MWAWChart::~MWAWChart | ( |  | ) |
| virtual

the destructor

## ◆ MWAWChart() [2/2]

MWAWChart::MWAWChart | ( | MWAWChart const & | orig | ) |
| explicit private delete

## Member Function Documentation

## ◆ add() [1/3]

void MWAWChart::add | ( | int | coord,
|  | MWAWChart::Axis const & | axis
| ) |  |

adds an axis (corresponding to a coord)

## ◆ add() [2/3]

void MWAWChart::add | ( | MWAWChart::Series const & | series | ) |

adds a series

## ◆ add() [3/3]

void MWAWChart::add | ( | MWAWChart::TextZone const & | textZone | ) |

adds a textzone

## ◆ getAxis()

MWAWChart::Axis const & MWAWChart::getAxis | ( | int | coord | ) | const

return an axis (corresponding to a coord)

## ◆ getDimension()

MWAWVec2f const& MWAWChart::getDimension | ( |  | ) | const
| inline

return the chart dimension

## ◆ getLegend()

Legend const& MWAWChart::getLegend | ( |  | ) | const
| inline

return the legend

## ◆ getSeries()

std::vector<Series> const& MWAWChart::getSeries | ( |  | ) | const
| inline

return the list of series

## ◆ getTextZone()

bool MWAWChart::getTextZone | ( | TextZone::Type | type,
|  | MWAWChart::TextZone & | textZone
| ) |  |

returns a textzone content(if set)

## ◆ operator=()

MWAWChart& MWAWChart::operator= | ( | MWAWChart const & | orig | ) |
| private delete

## ◆ sendChart()

void MWAWChart::sendChart | ( | MWAWSpreadsheetListenerPtr & | listener,
|  | librevenge::RVNGSpreadsheetInterface * | interface
| ) |  |

send the chart to the listener

Referenced by MWAWSpreadsheetListener::insertChart().

## ◆ sendContent()

virtual void MWAWChart::sendContent | ( | TextZone const & | zone,
|  | MWAWListenerPtr & | listener
| ) |  |
| pure virtual

send the zone content (called when the zone is of text type)

Implemented in BeagleWksSSParserInternal::Chart.

Referenced by sendTextZoneContent().

## ◆ sendTextZoneContent()

void MWAWChart::sendTextZoneContent | ( | TextZone::Type | type,
|  | MWAWListenerPtr & | listener
| ) |  |
| protected

sends a textzone content

Referenced by MWAWChartInternal::SubDocument::parse().

## ◆ set()

void MWAWChart::set | ( | Legend const & | legend | ) |
| inline

set the legend

## ◆ setDataType()

void MWAWChart::setDataType | ( | Series::Type | type,
|  | bool | dataStacked
| ) |  |
| inline

sets the chart type

## ◆ setDimension()

void MWAWChart::setDimension | ( | MWAWVec2f const & | dim | ) |
| inline

return the chart dimension

## Friends And Related Function Documentation

## ◆ MWAWChartInternal::SubDocument

friend class MWAWChartInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_axis

Axis MWAWChart::m_axis[4]
| protected

the x,y,z and a bad axis

Referenced by add(), getAxis(), and sendChart().

## ◆ m_dataStacked

bool MWAWChart::m_dataStacked
| protected

a flag to know if the data are stacked or not

Referenced by sendChart().

## ◆ m_dim

MWAWVec2f MWAWChart::m_dim
| protected

the chart dimension in point

Referenced by sendChart().

## ◆ m_fontConverter

MWAWFontConverterPtr MWAWChart::m_fontConverter
| protected

the font converter

Referenced by sendChart().

## ◆ m_legend

Legend MWAWChart::m_legend
| protected

the legend

Referenced by sendChart().

## ◆ m_seriesList

std::vector<Series> MWAWChart::m_seriesList
| protected

the list of series

Referenced by add(), and sendChart().

## ◆ m_sheetName

std::string MWAWChart::m_sheetName
| protected

the sheet name

Referenced by sendChart().

## ◆ m_textZoneMap

std::map<TextZone::Type, TextZone> MWAWChart::m_textZoneMap
| protected

a map text zone type to text zone

Referenced by add(), getTextZone(), sendChart(), and sendTextZoneContent().

## ◆ m_type

Series::Type MWAWChart::m_type
| protected

the chart type (if no series)

Referenced by sendChart().

The documentation for this class was generated from the following files:

- MWAWChart.hxx
- MWAWChart.cxx